
<?php

if (!defined('_PS_VERSION_'))
  exit;
if(!defined('SMILEPAY_C2CUP_MODULE'))
    define('SMILEPAY_C2CUP_MODULE',1);

define('SMILEPAY_C2CUP_MAP_SELECT',1);
define('SMILEPAY_C2CUP_MAP_ORDER_SUBMIT',2);


class Smilepay_c2cup extends CarrierModule
{
    const PREFIX = 'smilepay_c2cup_';
    const SMILEPAY_C2CUP_711_CARRIER_ID = 'SMILEPAY_C2CUP_711_CARRIER_ID'; 
    const SMILEPAY_C2CUP_711_CARRIER_ID_REF = 'SMILEPAY_C2CUP_711_CARRIER_ID_REF'; 

    protected $smseurl = 'http://ssl.smse.com.tw/api/sppayment.asp';
    private $_postErrors = array();
    public $Dcvc; 
    public $Rvg2c;
    public $VKey;
    public $id_carrier;
    public $id_ref_carrier;
    protected $emapurl = 'https://emap.presco.com.tw/c2cemap.ashx';
    protected $_hooks = array(
	    'actionCarrierUpdate', //For control change of the carrier's ID (id_carrier), the module must use the updateCarrier hook.
        //'beforeCarrier',
        'displayCarrierExtraContent',
        'displayOrderConfirmation',
        'actionCarrierProcess',
        'displayAdminOrderTabOrder',
        'displayAdminOrderContentOrder',
        'actionFrontControllerSetMedia', 
    );

    //Don't remove following comment.
    //Produce the lang string
    //$this->l('smilepay_c2cup_711');
    protected $_carriers_brief = array(
	   'smilepay_c2cup_711' => 
                                    array(
                                        'name'=>'smilepay_c2cup_711',
                                        'carrier_id_reconfig'=>self::SMILEPAY_C2CUP_711_CARRIER_ID,
                                        'carrier_id_ref_reconfig'=>self::SMILEPAY_C2CUP_711_CARRIER_ID_REF,
                                        ),
    );
    

    public function __construct()
    {
        $this->name = 'smilepay_c2cup';
        $this->tab = 'shipping_logistics';
        $this->version = '2.2.0';
        $this->author = 'SmilePay';
        //$this->need_instance = 0;
       // $this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_); 
        //$this->bootstrap = false;
 
        parent::__construct();
 
        $this->displayName = $this->l('smilepay_c2cup_name');
        $this->description = $this->l('Description of smilepay_c2cup');
 
        $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');

        $config = Configuration::getMultiple(array('SMILEPAY_c2cup_DCVC','SMILEPAY_c2cup_Rvg2c', 'SMILEPAY_c2cup_VKey',self::SMILEPAY_C2CUP_711_CARRIER_ID,self::SMILEPAY_C2CUP_711_CARRIER_ID_REF));

        if (isset($config['SMILEPAY_c2cup_DCVC']))
			$this->Dcvc = trim($config['SMILEPAY_c2cup_DCVC']);

		if (isset($config['SMILEPAY_c2cup_Rvg2c']))
			$this->Rvg2c =  trim($config['SMILEPAY_c2cup_Rvg2c']);

		if (isset($config['SMILEPAY_c2cup_VKey']))
			$this->VKey =  trim($config['SMILEPAY_c2cup_VKey']);			
        if (isset($config[self::SMILEPAY_C2CUP_711_CARRIER_ID]))
			$this->id_carrier =  trim($config[self::SMILEPAY_C2CUP_711_CARRIER_ID]);	
        if (isset($config[self::SMILEPAY_C2CUP_711_CARRIER_ID_REF]))
			$this->id_ref_carrier =  trim($config[self::SMILEPAY_C2CUP_711_CARRIER_ID_REF]);	

            

        if ((!isset($this->Dcvc) ||  empty($this->Dcvc)))
			$this->warning = $this->l('Dcvc is not setting');
        if ((!isset($this->Rvg2c) ||  empty($this->Rvg2c)))
			$this->warning = $this->l('Rvg2c is not setting');
        if ((!isset($this->VKey) ||  empty($this->VKey)))
			$this->warning = $this->l('VKey is not setting');

        if ((!isset($this->id_carrier) ||  empty($this->id_carrier)))
			$this->warning = $this->l('carrier error install');
        if ((!isset($this->id_ref_carrier) ||  empty($this->id_ref_carrier)))
			$this->warning = $this->l('carrier error install');
            
  }


  //create carrier
  protected function createCarriers()
  {
      
	
        return $this->_resetCarrierdata();
    }
    //delete carrier
    protected function deleteCarriers()
    {
        foreach($this->_carriers_brief as $carrier_brief)
        {
	        $tmp_carrier_id = Configuration::get($carrier_brief['carrier_id_reconfig']);
	        $carrier = new Carrier($tmp_carrier_id);
	        $carrier->delete();
        }
	    return TRUE;
    }
    // table
    protected function installDb()
    {
        return Db::getInstance()->execute('
		    CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'smilepay_c2cup_table` (
			 `id_smilepay_c2cup`  int(10) unsigned NOT NULL auto_increment,
			 `id_order` int(10) unsigned NOT NULL,
             `smse_id` TEXT NOT NULL ,
             `store_id` VARCHAR(50) NOT NULL ,
             `store_name` VARCHAR(50) NOT NULL ,
             `store_address` VARCHAR(255) NOT NULL ,
             `customer_name` VARCHAR(255) NOT NULL ,
             `customer_phone` VARCHAR(50) NOT NULL ,
             `amount` decimal(20,6) NOT NULL ,
             `c2cup_no` VARCHAR(255),
			 `btn_url` TEXT NOT NULL ,
			 `date_upd` datetime NOT NULL,
			 PRIMARY KEY(`id_smilepay_c2cup`)
		) ENGINE='._MYSQL_ENGINE_.' default CHARSET=utf8');
    }
    //insert data into table
    protected function insertC2CupResult($result)
    {

        if(!isset($result['Status']) || $result['Status']!=1)
            return false;
        foreach($result as $key =>$val)
        {
            if(!isset($val))
            {
                $result[$key]='';
            }
        }

        $smseid = $result['SmilePayNO'];
        $order_id = $result['Data_id'];
        $storeid = $result['StoreId'];
        $storename =$result['StoreName'];
        $storeaddress = $result['StoreAddress'];
        $customername=$result['CustomerName'];
        $phone=$result['CustomerPhone'];
        $amount =$result['Amount'];
        $_url=sprintf("http://ssl.smse.com.tw/api/C2CPaymentU.asp?types=web&Dcvc=%s&Smseid=%s&Verify_key=%s",$this->Dcvc,$smseid,$this->VKey);
        $btn_url ="<input type=button value='列印服務單'"." target='_blabk' onclick=window.open('".$_url."') />";
            
        return Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'smilepay_c2cup_table` (`id_order`, `smse_id`, `btn_url`, `date_upd`, `store_id`, `store_name`, `store_address`, `customer_name`, `customer_phone`, `amount`) 
                                    VALUES('. $order_id." ,\"$smseid\",\"$btn_url\",'". date("Y-m-d H:i:s")."', '$storeid','$storename','$storeaddress' ,'$customername' , '$phone' ,'$amount' );");

    }
    public function install()
    {
	    if (parent::install()) {
		    foreach ($this->_hooks as $hook) {
			    if (!$this->registerHook($hook)) {
				    return FALSE;
			    }
		    }
		    if (!$this->createCarriers()) { //function for creating new currier
         
			    return FALSE;
		    }
            if(!$this->installDb())
            {
         
                 return FALSE;
            }
               
		    return TRUE;
	    }
 
	    return FALSE;
    }


    public function uninstall()
    {
	    if (parent::uninstall()) {
		    foreach ($this->_hooks as $hook) {
			    if (!$this->unregisterHook($hook)) {
				    return FALSE;
			    }
		    }
 
		    if (!$this->deleteCarriers()) {
			    return FALSE;
		    }

            if(!$this->removeconfig())
                return FALSE;
 
		    return TRUE;
	    }
 
	    return FALSE;
    }

    protected function removeconfig()
    {
        if(!Configuration::deleteByName('SMILEPAY_c2cup_DCVC') || !Configuration::deleteByName('SMILEPAY_c2cup_Rvg2c')|| !Configuration::deleteByName('SMILEPAY_c2cup_VKey')
            ) 
            return false;
        if(!$this->removeCarrierConfig())
	        return false;
        return true;
    }
    protected function removeCarrierConfig()
    {
         $error =false;
         foreach($this->_carriers_brief as $carrier_brief)
         {
            if( !Configuration::deleteByName($carrier_brief['carrier_id_reconfig']) || !Configuration::deleteByName($carrier_brief['carrier_id_ref_reconfig'])) 
                $error = true;  
         }

         return !$error;
    }
    public function hookActionCarrierUpdate($params)
    {
        foreach($this->_carriers_brief as $carrier_brief)
        {
             if ($params['carrier']->id_reference == Configuration::get($carrier_brief['carrier_id_ref_reconfig'])) {
		        Configuration::updateValue($carrier_brief['carrier_id_reconfig'], $params['carrier']->id);
                $this->id_carrier = $params['carrier']->id;
                break;
	         }
        }
	   
    }



    
    public function hookDisplayOrderConfirmation($params)
    {
        return '';
    }
    //show Map button
    public function hookdisplayCarrierExtraContent($params)
    {
     
        /*$deliveryOptionList = $params['cart']->getDeliveryOptionList();
        if (count($deliveryOptionList) > 1 || empty($deliveryOptionList)) {
            return false;
        }
        foreach (reset($deliveryOptionList) as $key => $option) 
        {
              foreach ($option['carrier_list'] as $carrier) {
                    $l_carriers_id[] = $carrier['instance']->id;
              }
        }*/
  
        if(!in_array(Configuration::get(self::SMILEPAY_C2CUP_711_CARRIER_ID) , array($params['carrier']['id'])))
            return false;
              
        $carrier = new Carrier(Configuration::get(self::SMILEPAY_C2CUP_711_CARRIER_ID));
 
        if(!isset( $carrier) || empty($carrier))
            return false;
        elseif(!$carrier->active)
        {
            return false;
        }
        $url = $this->getEmapBtnUrl();
        $maptext = $this->l('select emap');
        $mapstoretext="";
        if($this->isShippingStoreSelected())
        {
           $store_data=$this->getStoreData();
           //$template_store = $this->l('store name') .  $store_data['storename'];
           $maptext = $this->l('select emap again');
           $mapstoretext =  sprintf($this->l('emap info text'),$store_data['storename'],$store_data['storeid'],$store_data['storeaddress']);
        }
        /*$cur_protocol = strpos(strtolower($_SERVER['SERVER_PROTOCOL']),'https') 
                === FALSE ? 'http' : 'https';
        $cur_host     = $_SERVER['HTTP_HOST'];
        $cur_script   = $_SERVER['SCRIPT_NAME'];
        $cur_params   = $_SERVER['QUERY_STRING'];
        parse_str($cur_params, $tmp_cur_params);

        if(isset($_REQUEST['step']) && !isset( $tmp_cur_params['step']))
        {
            if(empty($cur_params))
                 $cur_params  .= "?step=" . $_REQUEST['step'];
            else
                 $cur_params  .= "&step=" . $_REQUEST['step'];
        }
            
        $currentUrl = $cur_protocol . '://' . $cur_host . $cur_script . '?' . $cur_params;

        $this->setReturnCheckoutUrl($currentUrl );*/
     
        $template = "<div id='smilepay_c2cup_emap_but' ><button type='button'  onclick='window.open(\"$url\",\"_self\");' style='border-style:hidden;background-color: #4CAF50;color: white;min-width:80px;white-space:normal;padding:5px;'>".$maptext ."</button>&nbsp;&nbsp;&nbsp;&nbsp;"
                        .$mapstoretext."</div>";
                      // .$this->l('emap note') ."<span style='color:red;'>'".$this->getCarrierName()."'</span> ".$this->l('emap note2')."</br></br></br>";
                     

       /* $btnscript = "<script>
                        elemMapButton = document.getElementById('smilepay_c2cup_emap_but');
                        if(" .$params['cart']->id_carrier ." != ".$carrier->id.")
                        {
                              elemMapButton.style.display= 'none'; 
                         }
                        else
                             elemMapButton.style.display= 'block'; 
                        </script>";*/
        
        /*if(isset( $template_store))
        {
             $template .=  $template_store ."</br></br></br>";
        }*/
        if ( version_compare(_PS_VERSION_, '1.7.1.0', '>='))
        {
            $btnscript ="<script>var carrier_smilepayc2cup_711='".Configuration::get(self::SMILEPAY_C2CUP_711_CARRIER_ID)."';</script>";
        }
        else 
            $btnscript ="";

        return $template.  $btnscript;
       // return "<button type='button' onclick='window.open(\"$url\",\"_blank\");' style='border-style:hidden;height:30px;'>".$this->l('select emap') ."</button></br></br></br>";
     
    }
     

     //validation of name,phone and store info
    protected function _shippingValidate($params)
    {
       $context=Context::getContext();
       $address = new Address(intval($params['cart']->id_address_delivery));
       if(!is_null($address->phone_mobile) && !empty($address->phone_mobile))
            $phone = $address->phone_mobile;
       else
            $phone = $address->phone;
       if( !preg_match("/[^a-zA-Z0-9 ]/",$address->lastname .$address->firstname))
       {
           $limit_name_number =10;
       }
       else
       {
           $limit_name_number =5;
       }

       if(mb_strlen( $address->lastname .$address->firstname ,"utf-8" )> $limit_name_number) 
       {
           if (defined("_PS_VERSION_") && version_compare(_PS_VERSION_, '1.7.1.0', '>=')) {
            $context->controller->errors[] =$this->l('Shipping Name error');
           }
           else
            $context->controller->errors[] = Tools::displayError($this->l('Shipping Name error'));
       }
       if(!preg_match("/^[0][9][0-9]{8,8}\$/",$phone))
       {
           if (defined("_PS_VERSION_") && version_compare(_PS_VERSION_, '1.7.1.0', '>=')) {
            $context->controller->errors[] =$this->l('Shipping phone error');
           }
           else
            $context->controller->errors[] = Tools::displayError($this->l('Shipping phone error'));
       }
       if(!$this->isShippingStoreSelected())
       {
           if (defined("_PS_VERSION_") && version_compare(_PS_VERSION_, '1.7.1.0', '>=')) {
            $context->controller->errors[] =$this->l('Shipping Store is NOT selected');
           }
           else
            $context->controller->errors[] = Tools::displayError($this->l('Shipping Store is NOT selected'));
            
       }
       if($context->controller->errors)
         return false;
       else
         return true;
    
    }
    //validation of name,phone and store info api
    public function shippingValidate($cart)
    {
       if(!isset($cart) && empty($cart))
         return false;
       $params = array(
                    'cart'=>$cart,
                 );
       //validate
       $this->_shippingValidate($params);

       $context = Context::getContext();
       if($context->controller->errors)
         return false;
       else
         return true;
    }
    // hook of validation
    public function hookActionCarrierProcess($params)
    {

        if($params['cart']->id_carrier!=$this->id_carrier  ||  !Tools::isSubmit('confirmDeliveryOption'))
            return;
        
        $context=Context::getContext();
        if(! $this->_shippingValidate($params))
        {
            $rawData = Db::getInstance()->getValue(
                                        'SELECT checkout_session_data FROM '._DB_PREFIX_.'cart WHERE id_cart = '.(int) $this->context->cart->id
                        );
            $data = json_decode($rawData, true);

            if(isset( $data['checkout-delivery-step']))
            {
                $data['checkout-delivery-step']['step_is_complete']='';
                 
                
                Db::getInstance()->execute(
                    'UPDATE '._DB_PREFIX_.'cart SET checkout_session_data = "'.pSQL(json_encode($data)).'"
                                WHERE id_cart = '.(int) $this->context->cart->id
                    );
            }
           /* Db::getInstance()->execute(
                'Update '._DB_PREFIX_.'cart set  checkout_session_data="" WHERE id_cart = '.(int) $context->cart->id
            );*/
            $context->controller->redirectWithNotifications($context->link->getPageLink('order'));
          
        }
    
    }
   

    public function getOrderShippingCost($params, $shipping_cost)
    {
        //not to do
        return 0;
    }
    public function getOrderShippingCostExternal($params)
    {
        //not to do
        return 0;
    }

    //reset carrier data
    protected function _resetCarrierdata()
    { 
        foreach ($this->_carriers_brief as $carrier_brief_array)
        {
            $l_carrier_id = Configuration::get( $carrier_brief_array['carrier_id_reconfig']);
            $error = false;
            if(isset($l_carrier_id)&& !empty($l_carrier_id))
            {
                $carrier = new Carrier($l_carrier_id);
                if($carrier->deleted)
                {
                   if(!$this->_createOneCarrier($carrier_brief_array))
                    $error= true;  
                }
            }
            else
            {
               if(!$this->_createOneCarrier($carrier_brief_array))
                    $error= true;  
            }

        }
        return  !$error;
      
    }

    //
    protected function _createOneCarrier($carrier_brief_array)
    {
        $carrier = new Carrier();
		$carrier->name = $this->l($carrier_brief_array['name']);
        $carrier->active = TRUE;
		$carrier->deleted = 0;
		$carrier->shipping_handling = FALSE;
	    $carrier->range_behavior = 0;
		$carrier->delay[Configuration::get('PS_LANG_DEFAULT')] = 'days';
        $carrier->shipping_external = FALSE;
		$carrier->is_module = TRUE;
		$carrier->external_module_name = $this->name;
		$carrier->need_range = TRUE;
          
		if ($carrier->add()) {
			    $groups = Group::getGroups(true);
			    
                foreach ($groups as $group) {
				     Db::getInstance()->insert( 'carrier_group', array(
					    'id_carrier' => (int) $carrier->id,
					    'id_group' => (int) $group['id_group']
				    ));
		        }   
       
            copy(dirname(__FILE__) . '/icons/7-11.jpg' , _PS_SHIP_IMG_DIR_ . '/' . (int) $carrier->id . '.jpg');

            Configuration::updateValue($carrier_brief_array['carrier_id_reconfig'], $carrier->id);
		    Configuration::updateValue($carrier_brief_array['carrier_id_ref_reconfig'], $carrier->id);
            
        }
        else
            return false;
	    return TRUE;
    }


    //setup validation
    protected function _postValidation()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			if (!Tools::getValue('SMILEPAY_c2cup_DCVC'))
				$this->_postErrors[] = $this->l('Dcvc is not setting');
			elseif (!Tools::getValue('SMILEPAY_c2cup_Rvg2c'))
				$this->_postErrors[] = $this->l('Rvg2c is not setting');
            elseif (!Tools::getValue('SMILEPAY_c2cup_VKey'))
				$this->_postErrors[] = $this->l('VKey is not setting');
		}
	}
    //setup
    protected function _postProcess()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
            if(!is_null(Tools::getValue('SMILEPAY_c2cup_DCVC')))
                $dcvc = trim(Tools::getValue('SMILEPAY_c2cup_DCVC'));
            else
                $dcvc = Tools::getValue('SMILEPAY_c2cup_DCVC');

            if(!is_null(Tools::getValue('SMILEPAY_c2cup_Rvg2c')))
                $rvg2c = trim(Tools::getValue('SMILEPAY_c2cup_Rvg2c'));
            else
                $rvg2c =Tools::getValue('SMILEPAY_c2cup_Rvg2c');

            if(!is_null(Tools::getValue('SMILEPAY_c2cup_VKey')))
                $vkey = trim(Tools::getValue('SMILEPAY_c2cup_VKey'));
            else
                $vkey = Tools::getValue('SMILEPAY_c2cup_VKey');

			Configuration::updateValue('SMILEPAY_c2cup_DCVC', $dcvc);
			Configuration::updateValue('SMILEPAY_c2cup_Rvg2c', $rvg2c);
			Configuration::updateValue('SMILEPAY_c2cup_VKey', $vkey);

            //reset carrier
            if(!is_null(Tools::getValue('SMILEPAY_c2cup_Carrier_Reset_on')) && Tools::getValue('SMILEPAY_c2cup_Carrier_Reset_on')=='Y')
            {
                $this->_resetCarrierdata();
            }


		}
		$this->_html .= $this->displayConfirmation($this->l('Settings updated'));
	}


    //setup form
    public function renderForm()
	{
		$fields_form = array(
			'form' => array(
				'legend' => array(
					'title' => $this->l('smilepay_c2cup_title') .'<br/>'.$this->l('config_desc')."</br>".$this->l('config_note')."</br>"."</br>",
				//	'icon' => 'icon-envelope'
				),
				'input' => array(
					array(
						'type' => 'text',
						'label' => $this->l('DCVC_config'),
						'name' => 'SMILEPAY_c2cup_DCVC',
						'required' => true,
                        'size' => 40,
					),
					array(
						'type' => 'text',
						'label' => $this->l('Rvg2c_config'),
						'name' => 'SMILEPAY_c2cup_Rvg2c',
						'required' => true,
                       'size' => 40,
					),
                    array(
						'type' => 'text',
						'label' => $this->l('VKey_config'),
						'name' => 'SMILEPAY_c2cup_VKey',
						'required' => true,
                       'size' => 40,
					),
                    array(
                        'type' => 'checkbox',
                        'name' => 'SMILEPAY_c2cup_Carrier_Reset',
                        'label' =>'',
                        'values' => array(
                            'query' => array(
                                array('id' => 'on', 'name' => $this->l('Reset carrier config'), 'val' => 'Y'),
                                ),
                            'id' => 'id',
                            'name' => 'name'
                            )
                        ),
                      'size' => 40,
                 ),  
                
				'submit' => array(
					'title' => $this->l('Save'),
				    )
			),
            
		);
        
		$helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table = $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$this->fields_form = array();
		$helper->id = (int)Tools::getValue('id_carrier');
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'btnSubmit';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);
        
		return $helper->generateForm(array($fields_form));
	}
    //get setup param
    public function getConfigFieldsValues()
	{
		return array(
			'SMILEPAY_c2cup_DCVC' => Tools::getValue('SMILEPAY_c2cup_DCVC', Configuration::get('SMILEPAY_c2cup_DCVC')),
			'SMILEPAY_c2cup_Rvg2c' => Tools::getValue('SMILEPAY_c2cup_Rvg2c', Configuration::get('SMILEPAY_c2cup_Rvg2c')),
			'SMILEPAY_c2cup_VKey' => Tools::getValue('SMILEPAY_c2cup_VKey', Configuration::get('SMILEPAY_c2cup_VKey')),
		);
	}
    public function getContent()
	{
        $this->_html = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('btnSubmit'))
		{
			$this->_postValidation();
			if (!count($this->_postErrors))
				$this->_postProcess();
			else
				foreach ($this->_postErrors as $err)
					$this->_html .= $this->displayError($err);
		}
		else
			$this->_html .= '<br />';

	
		$this->_html .= $this->renderForm();

		return $this->_html;
	}
    //get map url
    public function getEmapBtnUrl()
    {
        //map mobile start
        $useragent=$_SERVER['HTTP_USER_AGENT'];
        if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
        {
            //pc
            $this->emapurl = "https://emap.presco.com.tw/c2cemap.ashx";
        }
        else
        {
            $this->emapurl = "https://emap.presco.com.tw/c2cemapm-u.ashx";
        }
        //map mobile end


        $result = $this->emapurl."?eshopid=870&servicetype=1&url=".  Tools::getProtocol(Tools::usingSecureMode()).$_SERVER['HTTP_HOST'].$this->getPathUri()."emapsave.php";
        return  $result;
    }

    //get carrier name
    public function getCarrierName($order_id)
    {
        if(isset($order_id) && !empty($order_id) )
        {
            $order = new Order($order_id);
            $carrier = new Carrier($order->id_carrier);
            if(isset($carrier->name) && !empty($carrier->name))
                return $carrier->name;
        }
         return '';   
    }
    //clear temp store info
    public function clearStoreData()
    {
         $cookie = new Cookie('smilepay_c2cup_storedata');
        

         $cookie->__unset('c2cup_id_cart');
         $cookie->__unset('status');
         $cookie->__unset('storeid');
         $cookie->__unset('storename');
         $cookie->__unset('storeaddress');
    }

    public function saveStoreData($storedata)
    {
         $cookie = new Cookie('smilepay_c2cup_storedata');
         $cookie->setExpire(time()+60*60);
         foreach($storedata as $key => $val)
         {
             $cookie->__set($key,$val);
         }
         
    }
    public function setReturnCheckoutUrl($url)
    {
         $cookie = new Cookie('smilepay_c2cup_checkouturl');
         $cookie->setExpire(time()+60*60);
         $cookie->__set('c2cemapurl',$url);
        
    }
    public function getReturnCheckoutUrl()
    {
         $cookie = new Cookie('smilepay_c2cup_checkouturl');
         $data=$cookie->__get('c2cemapurl');

         if( isset($data))
            return  $data; 
         else
            return false;

    }
    public function clearReturnCheckoutUrl()
    {
         $cookie = new Cookie('smilepay_c2cup_checkouturl');
         $cookie->__unset('c2cemapurl');

    }
    //get store data
    //    $result['c2cup_id_cart']: id_cart
    //    $result['status']: select status;
    //    $result['storeid'] 
    //    $result['storename']
    //    $result['storeaddress']
    public function getStoreData()
    {
        $cookie = new Cookie('smilepay_c2cup_storedata');
        $data=$cookie->getAll();

        isset($data['c2cup_id_cart']) ? $result['c2cup_id_cart'] = $data['c2cup_id_cart'] : $result['c2cup_id_cart'] ='' ;
        isset($data['status']) ?$result['status'] = $data['status'] : $result['status'] ='';
        isset($data['storeid']) ?$result['storeid'] = $data['storeid']: $result['storeid'] ='';
        isset($data['storename'])? $result['storename'] = $data['storename']: $result['storename'] ='';
        isset($data['storeaddress'])?  $result['storeaddress'] = $data['storeaddress']: $result['storeaddress'] ='';
        foreach($result as $key => $val)
        {
            if(!isset($val))
            {
                $result[$key]='';
            }
        }
        return $result;
    }
    //is selected store which token ship?
    public function isShippingStoreSelected($id_cart=null)
    {
        $storedata = $this->getStoreData();
        $context = Context::getContext();
        if(is_null($id_cart))
        {
            $id_cart = $context->cart->id;
        }
        if(!isset($storedata['c2cup_id_cart']) ||  $storedata['c2cup_id_cart'] !=$id_cart )
        {
            return false;
        }
        else
        {
             if( !isset($storedata['storeid']) || empty($storedata['storeid'])
                || !isset($storedata['storename']) || empty($storedata['storename'])
                || !isset($storedata['storeaddress']) || empty($storedata['storeaddress'])
             )
                return false;
             return true;
        }
        return false;
        
    }

    //get data from table
    protected function _getResultData($order_id)
    {
        $sql = 'select `id_order`,  `store_id`, `store_name`, `store_address`, `customer_name`, `customer_phone`, `amount` from `' ._DB_PREFIX_."smilepay_c2cup_table` where  `id_order`=$order_id ORDER BY `id_smilepay_c2cup` DESC;" ;
        $data = Db::getInstance()->getRow( $sql );
        if(isset($data) && !empty($data))
        {
            $result['Amount'] = $data['amount'];
            $result['Data_id'] = $data['id_order'];
            $result['Status'] = 1;
            $result['CustomerName'] = $data['customer_name'];
            $result['CustomerPhone'] = $data['customer_phone'];
            $result['StoreId'] = $data['store_id'];
            $result['StoreName'] = $data['store_name'];
            $result['StoreAddress'] = $data['store_address'];
            return $result;
        }
        else
        {
             $result['Status'] = -5;
        }
 

        return false;
       
    }
    //check select carrier that match it or not
    public function isSelectedC2cupShipping($id_carrier)
    {
        $l_carrier = new Carrier($id_carrier);
        
        if($l_carrier->id_reference == $this->id_ref_carrier)
          return true;
        else
          return false;
    }
    //change status
    protected function changeStatus($status)
    {
        $cookie = new Cookie('smilepay_c2cup_storedata');
        $cookie->__set('status',$status);
    }
    //get status
    protected function getStatus()
    {
        $cookie = new Cookie('smilepay_c2cup_storedata');
        $status = $cookie->__get('status');
        return !is_null($status)?$status : false;
    }

    //Description: Connect to SMSe create c2cup order
    //return: SMSe result array return when success,
    //return: error array when fail,
    public function runC2CupProcess($order_id)
    {
        if(!isset($order_id) || empty($order_id) )
        {
            $error['Status']='-1';
            $error['Desc']='Error Order id, input error!';
            return $error;
        }
        $order = new Order($order_id);
        
        if(!$this->isShippingStoreSelected($order->id_cart))
        {
          $error['Status']='-3';
          $error['Desc']= $this->l('store data error');
          $context=Context::getContext();
          $context->controller->errors[] = Tools::displayError( $error['Desc']);
          $this->addComment($error['Desc'],$order_id,false,true);
          return $error;
        }
        if(!$this->isSelectedC2cupShipping($order->id_carrier))
        {
          $error['Status']='-4';
          $error['Desc']= $this->l('shipping method error');
          return $error;
        }

        if($this->getStatus()==SMILEPAY_C2CUP_MAP_ORDER_SUBMIT)
        {
     
            $this->clearStoreData();
            $result = $this->_getResultData($order_id);
        
            return $result;
        }
      
        $address = new Address(intval($order->id_address_delivery));
        $customer = new Customer(intval($order->id_customer));
        if(!is_null($address->phone_mobile) && !empty($address->phone_mobile))
            $phone = $address->phone_mobile;
        else
            $phone = $address->phone;

        $customer_name = $address->lastname . $address->firstname ;
        $customer_email = $customer->email;
        $storedata = $this->getStoreData();
        $c2cStoreData = sprintf('%s/%s/%s',$storedata['storeid'],$storedata['storename'],$storedata['storeaddress']);
        $total = intval(round($order->getOrdersTotalPaid()));
       
        $postdata = array(
                        'Dcvc' =>trim( $this->Dcvc),
                        'Rvg2c' => trim($this->Rvg2c),
                        'Verify_key' =>trim($this->VKey),
                        'Pay_gdry' =>'TW',
                        'Od_sob' => $order->reference,
                        'Pay_zg' => 52,
                        'Pay_subzg'=> '7NET',
                        'Data_id' => $order_id,
                        'Amount' => $total,
                        'Pur_name' => $customer_name,
                        'Tel_number' =>  $address->phone,
                        'Mobile_number' => $phone,
                        'Email' => $customer_email,
                        'Logistics_store' =>$c2cStoreData,

                    );
   

        //connection start
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$this->smseurl);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
     
        $resultxml=curl_exec($ch); 
        curl_close($ch);
     
        if(!is_null( $resultxml) && !empty($resultxml) )
        {
            $xml = simplexml_load_string($resultxml);
            if (isset( $xml)) 
            {
                (strlen(trim($xml->PayEndDate)) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                  
                $result= array(
                    'PayEndDate' =>urldecode($xmlPayEndDate),
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'SmilePayNO'=> strval($xml->SmilePayNO),
                    'CustomerName' => $customer_name,
                    'CustomerPhone' => $phone,
                    'StoreId'=>$storedata['storeid'],
                    'StoreName'=>$storedata['storename'],
                    'StoreAddress'=>$storedata['storeaddress'],
                 ); 
                 
            }
            else
            {
                 $result = array(
                            'Status' => '-1000',
                            'Desc' => $this->l('get SMSe order fail'),    
                            'Data_id'=>$order_id,
                        );     
            }
        }
        else
        {
            $result = array(
                        'Status' => '-1000',
                        'Desc'=>$this->l('get SMSe order fail'),    
                        'Data_id'=>$order_id,
                    );     
        }
        $Smseid = $result['SmilePayNO'];

        $this->changeStatus(SMILEPAY_C2CUP_MAP_ORDER_SUBMIT); // chage state aviod twice process


        if( $result['Status']==1) //success
        {
           
            $admincomment = sprintf($this->l('store_order_info_comment_admin_success'),
                                        $this->getCarrierName($result['Data_id']),$Smseid,$storedata['storeid'],$storedata['storename'],$storedata['storeaddress'],$customer_name,$phone,$total);
            $customercomment = sprintf($this->l('store_order_info_comment_customer_success'),
                                        $this->getCarrierName($result['Data_id']),$storedata['storename'],$storedata['storeaddress'],$customer_name,$phone,$total);
            $this->addComment($admincomment,$order_id,true,false);
            $this->addComment($customercomment,$order_id,false,true);
            $this->insertC2CupResult( $result);
        }
        else
        {
            $admincomment = sprintf($this->l('store_order_info_comment_admin_fail'),
                                     $this->getCarrierName($result['Data_id']),$result['Status'],$result['Desc']);
            $customercomment = sprintf($this->l('store_order_info_comment_customer_fail'),
                                     $this->getCarrierName($result['Data_id']));
            $this->addComment($admincomment,$order_id,true,false);
            $this->addComment($customercomment,$order_id,false,true);
        }

        
                

        return $result;
        
    }
    //add comment
    public function addComment($message,$order_id,$visibility=false,$sendmail=false)
    {
        if(!isset($order_id) || empty($order_id))
        {
            return false;
        }
        $order = new Order($order_id);
        $customer = new Customer(intval($order->id_customer));
        $context = Context::getContext();

        $id_customer_thread = CustomerThread::getIdCustomerThreadByEmailAndIdOrder($customer->email, $order->id);
        if (!$id_customer_thread) 
        {
            $customer_thread = new CustomerThread();
            $customer_thread->id_contact = 0;
            $customer_thread->id_customer = (int)$order->id_customer;
            $customer_thread->id_shop = (int)$context->shop->id;
            $customer_thread->id_order = (int)$order->id;
            $customer_thread->id_lang = (int)$context->language->id;
            $customer_thread->email = $customer->email;
            $customer_thread->status = 'open';
            $customer_thread->token = Tools::passwdGen(12);
            $customer_thread->add();
        } 
        else
        {
            $customer_thread = new CustomerThread((int)$id_customer_thread);
        }

        $employees=Employee::getEmployees();


        $customer_message = new CustomerMessage();
        $customer_message->id_customer_thread = $customer_thread->id;
        $customer_message->id_employee =  $employees[0]['id_employee'];//(int)$context->employee->id; // for first employee
        $customer_message->message =$message;
        $customer_message->private = $visibility;
        $customer_message->add();

        $message = $customer_message->message;
        if (Configuration::get('PS_MAIL_TYPE', null, null, $order->id_shop) != Mail::TYPE_TEXT) {
                    $message = Tools::nl2br($customer_message->message);
        }
        if($sendmail)
        {
            $varsTpl = array(
                        '{lastname}' => $customer->lastname,
                        '{firstname}' => $customer->firstname,
                        '{id_order}' => $order->id,
                        '{order_name}' => $order->getUniqReference(),
                        '{message}' => $message
                        );
            @Mail::Send((int)$order->id_lang, 'order_merchant_comment',
                Mail::l('New message regarding your order', (int)$order->id_lang), $varsTpl, $customer->email,
                $customer->firstname.' '.$customer->lastname, null, null, null, null, _PS_MAIL_DIR_, true, (int)$order->id_shop);
        }
        
    }

    //Description: produce Template from input result
    //input result: the result of runC2CupProcess()
    //return: the template of result
    public function produceResultTemplate($result)
    {
        if(!isset($result['Status'])|| empty($result['Status']))return '';
        if( $result['Status']==1)
        {
             $this->smarty->assign(array(
                'smilepay_c2cup_title' => $this->getCarrierName($result['Data_id']),
				'smilepay_c2cup_status' => $result['Status'],
				'smilepay_c2cup_data_id' => $result['Data_id'],
				'smilepay_c2cup_customer_name' => $result['CustomerName'],
				'smilepay_c2cup_customer_phone' => $result['CustomerPhone'],
				'smilepay_c2cup_store_id' => $result['StoreId'],
                'smilepay_c2cup_store_name' => $result['StoreName'],
                'smilepay_c2cup_store_address' => $result['StoreAddress'],
                'smilepay_c2cup_amount' => intval(round($result['Amount'])),
			));
        }
        else
        {
             $this->smarty->assign(array(
                'smilepay_c2cup_title' => $this->getCarrierName($result['Data_id']),
				'smilepay_c2cup_status' => $result['Status'],
          
			
			));
        }
       
        return $this->display(__FILE__, 'smilepay_c2cup_result.tpl');
    }

    public function hookDisplayAdminOrderTabOrder($params)
	{
        $order= $params['order'];
        $rq = Db::getInstance()->executeS('select `id_smilepay_c2cup` from `'._DB_PREFIX_.'smilepay_c2cup_table` where id_order='.$order->id);
        if(isset($rq) && !empty($rq))
        {
            $this->smarty->assign(array(
                'smilepay_c2cup_data_num' => count($rq)
                ));
             return $this->display(__FILE__, '/views/templates/hook/tab_order.tpl');
        }
        return false;

        
		

	}
    
	public function hookDisplayAdminOrderContentOrder($params)
	{

		$order= $params['order'];

		$rq = Db::getInstance()->executeS('select * from `'._DB_PREFIX_.'smilepay_c2cup_table` where id_order='.$order->id);
        
        if(isset($rq) && !empty($rq))
        {
            //$button = $rq['btn_url'];
            $this->smarty->assign(array(
                'smilepay_c2cup_data_num' => 0,
                'smilepay_logo_url'=> $this->_path . "smilepay.jpg",
                'smilepay_c2cup_Data' => $rq
		        ));

		    return $this->display(__FILE__, '/views/templates/hook/content_order.tpl');
        }
        return false;
	}
    public function hookActionFrontControllerSetMedia($params)
    {
        if (!$this->active)
			return;

        if ( version_compare(_PS_VERSION_, '1.7.1.0', '>='))
        {
         
            if ('order' === $this->context->controller->php_self) {
                
                $this->context->controller->registerJavascript(
                    'module-smilepay_c2cup-emap',
                    'modules/'.$this->name.'/views/js/emap.js',
                    [
                        'priority' => 600,
                        'position' => 'bottom',
                    ]
                );
            }
        }
        

    }
}     


?>