<?php
/*
*
*  @author smilepay 
*  <service@smse.comt.w>
*/

include_once("smilepay_csv_orderst.php");
if (!defined('_PS_VERSION_'))
	exit;
use PrestaShop\PrestaShop\Core\Payment\PaymentOption;
class Smilepay_csv extends PaymentModule
{
	protected $_html = '';
	protected $_postErrors = array();

	public $Dcvc;
	public $Mid;
	public $Apiurl;
	
	public $Rvg2c;
    public $Storephone;
	public function __construct()
	{
		$this->name = 'smilepay_csv';
		$this->tab = 'payments_gateways';
		$this->version = '2.2.0';
		$this->author = 'SmilePay';
    
		$this->Apiurl = 'http://ssl.smse.com.tw/ezpos/mtmk_utf.asp';
		

		$this->currencies = true;
		$this->currencies_mode = 'checkbox';
		
		$config = Configuration::getMultiple(array('SMILEPAY_csv_DCVC', 'SMILEPAY_csv_MID','SMILEPAY_csv_Rvg2c','SMILEPAY_csv_VKey','SMILEPAY_csv_StorePhone','SMILEPAY_csv_paymentName','SMILEPAY_csv_Spdesc'));
		if (isset($config['SMILEPAY_csv_DCVC']))
			$this->Dcvc = $config['SMILEPAY_csv_DCVC'];
		if (isset($config['SMILEPAY_csv_MID']))
			$this->Mid = $config['SMILEPAY_csv_MID'];
		if (isset($config['SMILEPAY_csv_Rvg2c']))
			$this->Rvg2c = $config['SMILEPAY_csv_Rvg2c'];
        if (isset($config['SMILEPAY_csv_VKey']))
			$this->VKey = $config['SMILEPAY_csv_VKey'];		
        if(isset( $config['SMILEPAY_csv_StorePhone']))
            $this->Storephone = $config['SMILEPAY_csv_StorePhone'];	

        if (isset($config['SMILEPAY_csv_paymentName']))
			$this->paymentName = $config['SMILEPAY_csv_paymentName'];
	    else
            $this->paymentName = "";  

        if (isset($config['SMILEPAY_csv_Spdesc']))
			$this->Spdesc = $config['SMILEPAY_csv_Spdesc'];
	    else
            $this->Spdesc = "";
            	
		parent::__construct();

		$this->displayName = $this->l('Smilepay csv');
		$this->description = "Smilepay Services csv Payment";
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
        
        if(trim($this->paymentName)=="")
            $this->paymentName = $this->displayName;

		if ((!isset($this->Dcvc) || !isset($this->Mid)|| !isset($this->Rvg2c)|| !isset($this->VKey) || empty($this->Dcvc) || empty($this->Mid) || empty($this->Rvg2c)|| empty($this->VKey) ))
			$this->warning = $this->l('The  Shop code and Check code must be configured in order to use this module correctly.');
		if (!count(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency set for this module');	
     
	}

	public function install()
	{

		if (!parent::install() || !$this->registerHook('paymentOptions') || !$this->registerHook('paymentReturn')  )
			return false;


      

        
        if(!$this->registerHook('displayAdminOrderTabOrder') || !$this->registerHook('displayAdminOrderContentOrder')
            ||!$this->registerHook('displayOrderDetail'))
            return false;



         return  Db::getInstance()->execute('
		    CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'smilepay_csv_table` (
			 `id_smilepay_csv`  int(10) unsigned NOT NULL auto_increment,
			 `id_order` int(10) unsigned NOT NULL,
             `smse_id` TEXT NOT NULL ,
             `barcode1` VARCHAR(50) NOT NULL ,
             `barcode2` VARCHAR(50) NOT NULL ,
             `barcode3` VARCHAR(50) NOT NULL ,
             `dateline` VARCHAR(255) NOT NULL ,
             `amount` decimal(20,6) NOT NULL ,
			 `date_upd` datetime NOT NULL,
			 PRIMARY KEY(`id_smilepay_csv`)
		) ENGINE='._MYSQL_ENGINE_.' default CHARSET=utf8');

		
	}

	public function uninstall()
	{
    if (!Configuration::deleteByName('SMILEPAY_csv_DCVC') || !Configuration::deleteByName('SMILEPAY_csv_MID') || !Configuration::deleteByName('SMILEPAY_csv_Rvg2c')
                || !Configuration::deleteByName('SMILEPAY_csv_StorePhone')  || !Configuration::deleteByName('SMILEPAY_csv_VKey') || !Configuration::deleteByName('SMILEPAY_csv_paymentName')
                || !Configuration::deleteByName('SMILEPAY_csv_Spdesc') || !parent::uninstall())
			return false;
		return true;
	}

	private function _postValidation()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			if (!Tools::getValue('Dcvc'))
				$this->_postErrors[] = $this->l('Shop code field is required.');
			elseif (!Tools::getValue('Rvg2c'))
				$this->_postErrors[] = $this->l('Rvg2c code is required.');
            elseif (!Tools::getValue('VKey'))
				$this->_postErrors[] = $this->l('VKey code is required.');
			elseif (!Tools::getValue('Mid'))
				$this->_postErrors[] = $this->l('Check code is required.');			
		}
	}

	private function _postProcess()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
            if(!is_null(Tools::getValue('Dcvc')))
                $dcvc = trim(Tools::getValue('Dcvc'));
            else
                $dcvc = Tools::getValue('Dcvc');

            if(!is_null(Tools::getValue('Mid')))
                $mid = trim(Tools::getValue('Mid'));
            else
                $mid = Tools::getValue('Mid');

            if(!is_null(Tools::getValue('Rvg2c')))
                $rvg2c = trim(Tools::getValue('Rvg2c'));
            else
                $rvg2c = Tools::getValue('Rvg2c');

            if(!is_null(Tools::getValue('VKey')))
                $vkey = trim(Tools::getValue('VKey'));
            else
                $vkey = Tools::getValue('VKey');
            
             if(!is_null(Tools::getValue('paymentName')))
                $paymentName = trim(Tools::getValue('paymentName'));
            else
                $paymentName = Tools::getValue('paymentName');

            if(!is_null(Tools::getValue('Spdesc')))
                $spdesc = trim(Tools::getValue('Spdesc'));
            else
                $spdesc = Tools::getValue('Spdesc');

			Configuration::updateValue('SMILEPAY_csv_DCVC', $dcvc);
			Configuration::updateValue('SMILEPAY_csv_Rvg2c', $rvg2c);
			Configuration::updateValue('SMILEPAY_csv_VKey', $vkey);
			Configuration::updateValue('SMILEPAY_csv_MID',  $mid );
		    Configuration::updateValue('SMILEPAY_csv_StorePhone', Tools::getValue('Storephone'));
            Configuration::updateValue('SMILEPAY_csv_paymentName', $paymentName );
            Configuration::updateValue('SMILEPAY_csv_Spdesc', $spdesc );
		}
		$this->_html .=  $this->displayConfirmation($this->l('Settings updated'));
	}

	private function _displaySmilepay()
	{
		$this->_html .= '<img src="../modules/smilepay_csv/smilepay_csv.jpg" style="float:left; margin-right:15px;"><b>'.$this->l('This module allows you to accept payments by Smilepay csv.').'</b><br /><br />';
	}

	private function _displayForm()
	{
	(Configuration::get('SMILEPAY_csv_CUS')  == '1') ? $cus_csv_checked ='checked' : $cus_csv_checked='';
		$this->_html .=
		'<form action="'.Tools::htmlentitiesUTF8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset>
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Contact details').'</legend>
				<table border="0" width="500" cellpadding="0" cellspacing="0" id="form">
					<tr><td colspan="2">'.$this->l('Please specify the Shop code and Check code to smilepay csv.').'.<br /><br /></td></tr>
					<tr><td width="130" style="height: 35px;">'.$this->l('Shop code').'</td><td><input type="text" name="Dcvc" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Dcvc', $this->Dcvc)).'" style="width: 300px;" /></td></tr>

                    <tr>
						<td  width="130" style="height: 35px;">'.$this->l('Shop rvg2c').'</td>
						<td><input type="text" name="Rvg2c" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Rvg2c', $this->Rvg2c)).'" style="width: 300px;" /></td>
					</tr>
					<tr>
						<td  width="130" style="height: 35px;">'.$this->l('Shop VKey').'</td>
						<td><input type="text" name="VKey" value="'.Tools::htmlentitiesUTF8(Tools::getValue('VKey', $this->VKey)).'" style="width: 300px;" /></td>
					</tr>
                    <tr >
						<td  width="130" style="height: 35px;"">'.$this->l('Check code').'</td>
						<td><input type="text" name="Mid" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Mid', $this->Mid)).'" style="width: 300px;" />  </td>
					</tr>				
					<tr>
						<td  width="130" style="height: 35px;">'.$this->l('Shop phone').'</td>
						<td><input type="text" name="Storephone" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Storephone', $this->Storephone)).'" style="width: 300px;" /></td>
					</tr>
                    <tr>
					    <td width="130" style="height: 35px;">'.$this->l('Front Payment Name').'</td>
					    <td><input type="text" name="paymentName" value="'.Tools::htmlentitiesUTF8(Tools::getValue('paymentName', $this->paymentName)).'" style="width: 300px;" /></td>
				    </tr>
                    <tr>
						<td width="130" style="height: 70px;">'.$this->l('Payment Description Of Frontend').'</td>
						<td><textarea name="Spdesc" style="width: 300px;height: 70px">'.Tools::htmlentitiesUTF8(Tools::getValue('Spdesc', $this->Spdesc)).'</textarea></td>
					</tr>				
					<tr><td colspan="2" align="center"><br /><input class="button" name="btnSubmit" value="'.$this->l('Update settings').'" type="submit" /></td></tr>
				</table>
			</fieldset>
		</form>';
	}

	public function getContent()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';

		if (Tools::isSubmit('btnSubmit'))
		{
			$this->_postValidation();
			if (!count($this->_postErrors))
				$this->_postProcess();
			else
				foreach ($this->_postErrors as $err)
					$this->_html .=  $this->displayError($err);
		}
		else
			$this->_html .= '<br />';

		$this->_displaySmilepay();
		$this->_displayForm();

		return $this->_html;
	}


	public function hookPaymentOptions($params)
	{
		if (!$this->active)
			return;
		if (!$this->checkCurrency($params['cart']))
			return;
        //Is shipping type of Smilepay_c2c?
        if(defined('SMILEPAY_C2CP_MODULE'))
        {
            $smilepay_c2cp_obj = new Smilepay_c2c();
            if($smilepay_c2cp_obj->active && $smilepay_c2cp_obj->isSmilepay_c2cp_shipping($params['cart']->id_carrier))
                return;
        }
        else
        {
            if(file_exists('modules/smilepay_c2c/smilepay_c2c.php'))
            {
                include_once('modules/smilepay_c2c/smilepay_c2c.php');
                $smilepay_c2cp_obj = new Smilepay_c2c();
                if($smilepay_c2cp_obj->active && $smilepay_c2cp_obj->isSmilepay_c2cp_shipping($params['cart']->id_carrier))
                    return;


            }
               
        }

		$this->smarty->assign(
            $this->getTemplateVars()
        );

        $newOption = new PaymentOption();
        $newOption->setCallToActionText($this->paymentName)
                ->setAction($this->context->link->getModuleLink($this->name, 'validation', array(), true))
                ->setAdditionalInformation($this->fetch('module:smilepay_csv/views/templates/hook/payment_info.tpl'));

        return [$newOption];
	}

    public function getTemplateVars()
    {
        $cart = $this->context->cart;
    

        return [
            'Description' => $this->Spdesc,     
        ];
    }

	public function hookPaymentReturn($params)
	{     
 
		if (!$this->active)
			return;

        $result = $this->getResultData();
        //<smilepay_c2cup> start
        $c2cup_template = ''; 
        $c2cup_run = false;
        //<smilepay_c2cup> end
        if(isset($result) && !empty($result))
        {
            $Status = $result['Status'];
          
			if($Status=="1")
            {
                $order = new Order($result['Data_id']);

                $shopurl = new ShopUrl($order->id_shop);
                  

                $this->smarty->assign(array(
                    'Status' =>  $result['Status'],
					'barcode1' => $result['Barcode1'],
                    'barcode2' => $result['Barcode2'],
                    'barcode3' => $result['Barcode3'],
					'dead_date' => $result['PayEndDate'],
					'SmilePayNO' => $result['SmilePayNO'],
                    'total' =>  $result['Amount'],
                    'data_id' => $result['Data_id'],
					'this_path' => $this->_path,    
                    'shop_url' => $shopurl->getURL(),
                    'order_ref_id' => $order->reference,
                    'shop_phone' =>  $this->Storephone,
				));

				 //<smilepay_c2cup> start
                if(file_exists("modules/smilepay_c2cup/smilepay_c2cup.php"))
                {
                    include_once("modules/smilepay_c2cup/smilepay_c2cup.php");
                    $smilepay_c2cup_obj = new Smilepay_c2cup();   
                    if($smilepay_c2cup_obj->isSelectedC2cupShipping($params['order']->id_carrier))
                    {
                        $result = $smilepay_c2cup_obj->runC2CupProcess($params['order']->id);
                        $c2cup_template = $smilepay_c2cup_obj->produceResultTemplate($result);
                        $c2cup_run = true;
		            // $c2cup_template is saved output html
                    }
                }
                
                //<smilepay_c2cup> end
            }
            else
            {
                $this->smarty->assign(array(
					'Status' =>$result['Status'],
					'Msg' => "錯誤,請與店家聯繫",
					'PayEndDate' => "",
					'SmilePayNO' => "",
                    'Amount' => "",
					'this_path' => $this->_path,
				));
				$msg= $xml->Status;
				$newOrderStatusId="6";
				$history = new OrderHistory();
				$history->id_order = (int)($params['order']->id);
				$history->changeIdOrderState($newOrderStatusId,$params['order']->id);
				$history->addWithemail();
            }
        }
        else
        {
            $this->smarty->assign(array(

					'Status' =>  '未如預期錯誤',

					'Msg' => '未知錯誤，請先確認訂單是否有錯，若有問題請與商家聯絡',

					'PayEndDate' => "",

					'SmilePayNO' => "",

                    'Amount' => "",

					'this_path' => $this->_path,

				));


        }
        /*
        //<smilepay_c2cup> start
        $c2cup_template = ''; 
        $c2cup_run = false;
        //<smilepay_c2cup> end
        //取得csv狀態編號
		$rq = Db::getInstance()->getRow('SELECT `id_order_state` FROM `'._DB_PREFIX_.'order_state_lang` WHERE id_lang = \''.pSQL('1').'\' AND  template = \'SmilePay_csv_status\'');
		//$rq['id_order_state']
		$csv_status=$rq['id_order_state'];

		$state = $params['objOrder']->getCurrentState();
		if ($state != $csv_status)
		{ 
		
			$id_order = trim($_GET['id_order']);
			$id_cart = trim($_GET['id_cart']);   
			$id_module = trim($_GET['id_module']);
			$key = trim($_GET['key']);	
			$user_address = new Address(intval($params['cart']->id_address_invoice));
			
			//取號
			$smilepay_gateway = 'https://ssl.smse.com.tw/api/sppayment.asp';
			$post_str = 'Dcvc=' . $this->Dcvc .
					'&Pay_zg=3' .
					'&Rvg2c=' . $this->Rvg2c .
					'&Pur_name=' .$params['cookie']->customer_lastname.$params['cookie']->customer_firstname.
					'&Tel_number=' .$user_address->phone.
					'&Mobile_number=' .$user_address->phone_mobile.
					'&Email=' .$params['cookie']->email.
					'&Data_id=' .$params['objOrder']->id.
					'&od_sob=' . $SmilePayibon_args['od_sob'].
					'&Amount=' . round($params['total_to_pay']).
					'&Roturl=' . "http://".$_SERVER["HTTP_HOST"].$this->_path."sprespon.php".
					'&Roturl_status=' . "psok2".					
					'&Verify_key=' . $this->VKey;
		
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
			curl_setopt($ch, CURLOPT_VERBOSE, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_str);
			$string = curl_exec($ch);
			curl_close($ch);
			$xml = simplexml_load_string($string);
			$Status = $xml->Status;
			if($Status=="1")
			{
           		$history = new OrderHistory();
				$newOrderStatusId=$csv_status;
				$history->id_order = (int)($params['objOrder']->id);
				$history->changeIdOrderState($newOrderStatusId,$params['objOrder']->id);
				$history->addWithemail();
				$this->smarty->assign(array(
					'Status' => $xml->Status,
					'barcode1' => $xml->Barcode1,
                    'barcode2' => $xml->Barcode2,
                    'barcode3' => $xml->Barcode3,
					'dead_date' => $xml->PayEndDate,
					'SmilePayNO' => $xml->SmilePayNO,
                    'total' => $xml->Amount,
                    'data_id'=>$xml->Data_id,
					'this_path' => $this->_path,
				));
				$msg= "繳費方式：超商帳單繳費，"."繳費條碼：".$xml->Barcode2."，"."截止期限：".$xml->PayEndDate."<br>追蹤碼".$xml->SmilePayNO;
				//$ibonmsg=$msg;
				//Db::getInstance()->Execute('UPDATE `'._DB_PREFIX_.'orders` SET  `smilepayc2ctable` = "'.$ibonmsg.'"  WHERE  `id_order` ='.$params['objOrder']->id);
			    Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'smilepay_csv_table` (`id_order` , `smse_id`,`barcode1`,`barcode2`,`barcode3`, `dateline`,`amount`,`date_upd`) values('
                                    .$params['objOrder']->id .",'".$xml->SmilePayNO."','" .$xml->Barcode1."','".$xml->Barcode2."','".$xml->Barcode3."','".$xml->PayEndDate."','".  $xml->Amount. "','"  .date("Y-m-d H:i:s")."');" );
 	            //<smilepay_c2cup> start
            
                include_once("modules/smilepay_c2cup/smilepay_c2cup.php");
           
                $smilepay_c2cup_obj = new Smilepay_c2cup();
          
                if($smilepay_c2cup_obj->isSelectedC2cupShipping($params['objOrder']->id_carrier))
                {
                    $result = $smilepay_c2cup_obj->runC2CupProcess($params['objOrder']->id);
                    $c2cup_template = $smilepay_c2cup_obj->produceResultTemplate($result);
		            $c2cup_run = true;
		            // $c2cup_template is saved output html
                }
            
                //<smilepay_c2cup> end

			}
			else
			{
				$this->smarty->assign(array(
					'Status' => $xml->Status,
					'Msg' => "錯誤,請與店家聯繫",
					'PayEndDate' => "",
					'SmilePayNO' => "",
                    'Amount' => "",
					'this_path' => $this->_path,
				));
				$msg= $xml->Status;
				$newOrderStatusId="6";
				$history = new OrderHistory();
				$history->id_order = (int)($params['objOrder']->id);
				$history->changeIdOrderState($newOrderStatusId,$params['objOrder']->id);
				$history->addWithemail();
			}
			//寫入備註
			Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'customer_thread` (`id_shop`, `id_lang`, `id_contact`, `id_customer`, `id_order`, `id_product`, `status`)VALUES(1,1,0,2,'.$params['objOrder']->id.',0,\'open\' )');
			$id_customer_thread = Db::getInstance()->getRow('SELECT `id_customer_thread` FROM `'._DB_PREFIX_.'customer_thread` WHERE id_order = '.$params['objOrder']->id);
			Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'customer_message` (`id_customer_thread`, `id_employee`, `message`,`date_add`,`date_upd`)VALUES('.$id_customer_thread['id_customer_thread'].',0,"'.$msg.'","'. date("Y-m-d H:i:s").'","'. date("Y-m-d H:i:s").'")');
        */
        //<smilepay_c2cup> start
            if($c2cup_run)
                return   $c2cup_template .  $this->display(__FILE__, 'payment_return.tpl');
        //<smilepay_c2cup> end
		    return $this->display(__FILE__, 'payment_return.tpl');
        //}
	}

	public function checkCurrency($cart)
	{
		$currency_order = new Currency((int)($cart->id_currency));
		$currencies_module = $this->getCurrency((int)$cart->id_currency);

		if (is_array($currencies_module))
			foreach ($currencies_module as $currency_module)
				if ($currency_order->id == $currency_module['id_currency'])
					return true;
		return false;
	}
    public function hookDisplayAdminOrderTabOrder($params)
	{
        $order= $params['order'];
        $rq = Db::getInstance()->executeS('select `id_smilepay_csv` from `'._DB_PREFIX_.'smilepay_csv_table` where id_order='.$order->id);
        if(isset($rq) && !empty($rq))
        {
            $this->smarty->assign(array(
                'smilepay_csv_data_num' => count($rq)
                ));
             return $this->display(__FILE__, '/views/templates/hook/tab_order.tpl');
        }
        return false;

	}
    
	public function hookDisplayAdminOrderContentOrder($params)
	{

		$order= $params['order'];

		$rq = Db::getInstance()->executeS('select * from `'._DB_PREFIX_.'smilepay_csv_table` where id_order='.$order->id);
        
        if(isset($rq) && !empty($rq))
        {
         
            $this->smarty->assign(array(
                'smilepay_csv_data_num' => 0,
                'order_id' => $order->id,
              //  'smilepay_logo_url'=> $this->_path . "smilepay.jpg",
                'bill_gen_controller_url' => Context::getContext()->link->getModuleLink('smilepay_csv', 'billgen'),
                'smilepay_csv_Data' => $rq
		        ));

		    return $this->display(__FILE__, '/views/templates/hook/content_order.tpl');
        }
        return false;
	}

    public function hookDisplayOrderDetail($params)
    {
       	$order= $params['order'];
		$rq = Db::getInstance()->executeS('select * from `'._DB_PREFIX_.'smilepay_csv_table` where id_order='.$order->id);
        
        if(isset($rq) && !empty($rq))
        {
           

               
                 
            $this->smarty->assign(array(
                'smilepay_csv_title' => $this->displayName,
                'order_id' => $order->id,
              //  'smilepay_logo_url'=> $this->_path . "smilepay.jpg",
                'bill_gen_controller_url' => Context::getContext()->link->getModuleLink('smilepay_csv', 'billgen'),
                'smilepay_csv_Data' => $rq,
                'smilepay_csv_path' => $this->_path,
		        ));
                
		    return $this->fetch('module:smilepay_csv/views/templates/front/content_order_front.tpl');
        }
        return false;

    }

    public function saveResultData($result)
    {
        $cookie = new Cookie('smilepay_csv_result');
        $cookie->setExpire(time()+60*60);


         
        foreach($result as $key => $val)
        {
            $cookie->__set($key,$val);
        }
        
    }
    public function getResultData()
    {
        $cookie = new Cookie('smilepay_csv_result');
        $data = $cookie->getAll();

      
        if( isset($data['Status'])  && !empty($data['Status']))
        {
            $result['Status'] = $data['Status'];

            if( $result['Status'] == 1)
            {
                $result['Barcode1'] = $data['Barcode1'];
                $result['Barcode2'] = $data['Barcode2'];
                $result['Barcode3'] = $data['Barcode3'];
                $result['PayEndDate'] = $data['PayEndDate'];
                $result['SmilePayNO'] = $data['SmilePayNO'];
                $result['Amount'] = $data['Amount'];
                $result['Data_id'] = $data['Data_id'];
            }
            else
            {
                $result['Desc'] = $data['Desc'];
            }
            
         
        }
        else
            return false;

        return $result;
    }

}
